require 'omniauth/strategies/oauth2'

module OmniAuth
  module Strategies
    class Passety < OmniAuth::Strategies::OAuth2
      API_URL  = ENV['PASSETY_API_URL']   || 'https://api.passety.com'
      SITE_URL = ENV['PASSETY_OAUTH_URL'] || 'https://passety.com'

      option :name, :passety

      option :client_options, {
        site: API_URL,
        authorize_url: "#{SITE_URL}/oauth/authorize",
        token_url:     "#{SITE_URL}/oauth/token"
      }

      uid { raw_info['id'] }

      info do
        {
          name:       raw_info['name'],
          first_name: raw_info['first_name'],
          last_name:  raw_info['last_name'],
          email:      raw_info['email'],
          location:   raw_info['location'],
          image:      raw_info['image']
        }
      end

      def raw_info
        @raw_info ||= access_token.get('/me').parsed
      end
    end
  end
end

